// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from novatel_oem7_msgs:msg/RAWIMUSX.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "novatel_oem7_msgs/msg/rawimusx.hpp"


#ifndef NOVATEL_OEM7_MSGS__MSG__DETAIL__RAWIMUSX__STRUCT_HPP_
#define NOVATEL_OEM7_MSGS__MSG__DETAIL__RAWIMUSX__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'nov_header'
#include "novatel_oem7_msgs/msg/detail/oem7_header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__novatel_oem7_msgs__msg__RAWIMUSX __attribute__((deprecated))
#else
# define DEPRECATED__novatel_oem7_msgs__msg__RAWIMUSX __declspec(deprecated)
#endif

namespace novatel_oem7_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RAWIMUSX_
{
  using Type = RAWIMUSX_<ContainerAllocator>;

  explicit RAWIMUSX_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    nov_header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->imu_info = 0;
      this->imu_type = 0;
      this->gnss_week = 0;
      this->gnss_week_seconds = 0.0;
      std::fill<typename std::array<uint8_t, 4>::iterator, uint8_t>(this->imu_status.begin(), this->imu_status.end(), 0);
      this->z_acc = 0l;
      this->y_acc = 0l;
      this->x_acc = 0l;
      this->z_gyro = 0l;
      this->y_gyro = 0l;
      this->x_gyro = 0l;
    }
  }

  explicit RAWIMUSX_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    nov_header(_alloc, _init),
    imu_status(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->imu_info = 0;
      this->imu_type = 0;
      this->gnss_week = 0;
      this->gnss_week_seconds = 0.0;
      std::fill<typename std::array<uint8_t, 4>::iterator, uint8_t>(this->imu_status.begin(), this->imu_status.end(), 0);
      this->z_acc = 0l;
      this->y_acc = 0l;
      this->x_acc = 0l;
      this->z_gyro = 0l;
      this->y_gyro = 0l;
      this->x_gyro = 0l;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _nov_header_type =
    novatel_oem7_msgs::msg::Oem7Header_<ContainerAllocator>;
  _nov_header_type nov_header;
  using _imu_info_type =
    uint8_t;
  _imu_info_type imu_info;
  using _imu_type_type =
    uint8_t;
  _imu_type_type imu_type;
  using _gnss_week_type =
    uint16_t;
  _gnss_week_type gnss_week;
  using _gnss_week_seconds_type =
    double;
  _gnss_week_seconds_type gnss_week_seconds;
  using _imu_status_type =
    std::array<uint8_t, 4>;
  _imu_status_type imu_status;
  using _z_acc_type =
    int32_t;
  _z_acc_type z_acc;
  using _y_acc_type =
    int32_t;
  _y_acc_type y_acc;
  using _x_acc_type =
    int32_t;
  _x_acc_type x_acc;
  using _z_gyro_type =
    int32_t;
  _z_gyro_type z_gyro;
  using _y_gyro_type =
    int32_t;
  _y_gyro_type y_gyro;
  using _x_gyro_type =
    int32_t;
  _x_gyro_type x_gyro;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__nov_header(
    const novatel_oem7_msgs::msg::Oem7Header_<ContainerAllocator> & _arg)
  {
    this->nov_header = _arg;
    return *this;
  }
  Type & set__imu_info(
    const uint8_t & _arg)
  {
    this->imu_info = _arg;
    return *this;
  }
  Type & set__imu_type(
    const uint8_t & _arg)
  {
    this->imu_type = _arg;
    return *this;
  }
  Type & set__gnss_week(
    const uint16_t & _arg)
  {
    this->gnss_week = _arg;
    return *this;
  }
  Type & set__gnss_week_seconds(
    const double & _arg)
  {
    this->gnss_week_seconds = _arg;
    return *this;
  }
  Type & set__imu_status(
    const std::array<uint8_t, 4> & _arg)
  {
    this->imu_status = _arg;
    return *this;
  }
  Type & set__z_acc(
    const int32_t & _arg)
  {
    this->z_acc = _arg;
    return *this;
  }
  Type & set__y_acc(
    const int32_t & _arg)
  {
    this->y_acc = _arg;
    return *this;
  }
  Type & set__x_acc(
    const int32_t & _arg)
  {
    this->x_acc = _arg;
    return *this;
  }
  Type & set__z_gyro(
    const int32_t & _arg)
  {
    this->z_gyro = _arg;
    return *this;
  }
  Type & set__y_gyro(
    const int32_t & _arg)
  {
    this->y_gyro = _arg;
    return *this;
  }
  Type & set__x_gyro(
    const int32_t & _arg)
  {
    this->x_gyro = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    novatel_oem7_msgs::msg::RAWIMUSX_<ContainerAllocator> *;
  using ConstRawPtr =
    const novatel_oem7_msgs::msg::RAWIMUSX_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<novatel_oem7_msgs::msg::RAWIMUSX_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<novatel_oem7_msgs::msg::RAWIMUSX_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      novatel_oem7_msgs::msg::RAWIMUSX_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<novatel_oem7_msgs::msg::RAWIMUSX_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      novatel_oem7_msgs::msg::RAWIMUSX_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<novatel_oem7_msgs::msg::RAWIMUSX_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<novatel_oem7_msgs::msg::RAWIMUSX_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<novatel_oem7_msgs::msg::RAWIMUSX_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__novatel_oem7_msgs__msg__RAWIMUSX
    std::shared_ptr<novatel_oem7_msgs::msg::RAWIMUSX_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__novatel_oem7_msgs__msg__RAWIMUSX
    std::shared_ptr<novatel_oem7_msgs::msg::RAWIMUSX_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RAWIMUSX_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->nov_header != other.nov_header) {
      return false;
    }
    if (this->imu_info != other.imu_info) {
      return false;
    }
    if (this->imu_type != other.imu_type) {
      return false;
    }
    if (this->gnss_week != other.gnss_week) {
      return false;
    }
    if (this->gnss_week_seconds != other.gnss_week_seconds) {
      return false;
    }
    if (this->imu_status != other.imu_status) {
      return false;
    }
    if (this->z_acc != other.z_acc) {
      return false;
    }
    if (this->y_acc != other.y_acc) {
      return false;
    }
    if (this->x_acc != other.x_acc) {
      return false;
    }
    if (this->z_gyro != other.z_gyro) {
      return false;
    }
    if (this->y_gyro != other.y_gyro) {
      return false;
    }
    if (this->x_gyro != other.x_gyro) {
      return false;
    }
    return true;
  }
  bool operator!=(const RAWIMUSX_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RAWIMUSX_

// alias to use template instance with default allocator
using RAWIMUSX =
  novatel_oem7_msgs::msg::RAWIMUSX_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace novatel_oem7_msgs

#endif  // NOVATEL_OEM7_MSGS__MSG__DETAIL__RAWIMUSX__STRUCT_HPP_
