// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from novatel_oem7_msgs:msg/RAWIMUSX.idl
// generated code does not contain a copyright notice
#include "novatel_oem7_msgs/msg/detail/rawimusx__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `nov_header`
#include "novatel_oem7_msgs/msg/detail/oem7_header__functions.h"

bool
novatel_oem7_msgs__msg__RAWIMUSX__init(novatel_oem7_msgs__msg__RAWIMUSX * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    novatel_oem7_msgs__msg__RAWIMUSX__fini(msg);
    return false;
  }
  // nov_header
  if (!novatel_oem7_msgs__msg__Oem7Header__init(&msg->nov_header)) {
    novatel_oem7_msgs__msg__RAWIMUSX__fini(msg);
    return false;
  }
  // imu_info
  // imu_type
  // gnss_week
  // gnss_week_seconds
  // imu_status
  // z_acc
  // y_acc
  // x_acc
  // z_gyro
  // y_gyro
  // x_gyro
  return true;
}

void
novatel_oem7_msgs__msg__RAWIMUSX__fini(novatel_oem7_msgs__msg__RAWIMUSX * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // nov_header
  novatel_oem7_msgs__msg__Oem7Header__fini(&msg->nov_header);
  // imu_info
  // imu_type
  // gnss_week
  // gnss_week_seconds
  // imu_status
  // z_acc
  // y_acc
  // x_acc
  // z_gyro
  // y_gyro
  // x_gyro
}

bool
novatel_oem7_msgs__msg__RAWIMUSX__are_equal(const novatel_oem7_msgs__msg__RAWIMUSX * lhs, const novatel_oem7_msgs__msg__RAWIMUSX * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // nov_header
  if (!novatel_oem7_msgs__msg__Oem7Header__are_equal(
      &(lhs->nov_header), &(rhs->nov_header)))
  {
    return false;
  }
  // imu_info
  if (lhs->imu_info != rhs->imu_info) {
    return false;
  }
  // imu_type
  if (lhs->imu_type != rhs->imu_type) {
    return false;
  }
  // gnss_week
  if (lhs->gnss_week != rhs->gnss_week) {
    return false;
  }
  // gnss_week_seconds
  if (lhs->gnss_week_seconds != rhs->gnss_week_seconds) {
    return false;
  }
  // imu_status
  for (size_t i = 0; i < 4; ++i) {
    if (lhs->imu_status[i] != rhs->imu_status[i]) {
      return false;
    }
  }
  // z_acc
  if (lhs->z_acc != rhs->z_acc) {
    return false;
  }
  // y_acc
  if (lhs->y_acc != rhs->y_acc) {
    return false;
  }
  // x_acc
  if (lhs->x_acc != rhs->x_acc) {
    return false;
  }
  // z_gyro
  if (lhs->z_gyro != rhs->z_gyro) {
    return false;
  }
  // y_gyro
  if (lhs->y_gyro != rhs->y_gyro) {
    return false;
  }
  // x_gyro
  if (lhs->x_gyro != rhs->x_gyro) {
    return false;
  }
  return true;
}

bool
novatel_oem7_msgs__msg__RAWIMUSX__copy(
  const novatel_oem7_msgs__msg__RAWIMUSX * input,
  novatel_oem7_msgs__msg__RAWIMUSX * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // nov_header
  if (!novatel_oem7_msgs__msg__Oem7Header__copy(
      &(input->nov_header), &(output->nov_header)))
  {
    return false;
  }
  // imu_info
  output->imu_info = input->imu_info;
  // imu_type
  output->imu_type = input->imu_type;
  // gnss_week
  output->gnss_week = input->gnss_week;
  // gnss_week_seconds
  output->gnss_week_seconds = input->gnss_week_seconds;
  // imu_status
  for (size_t i = 0; i < 4; ++i) {
    output->imu_status[i] = input->imu_status[i];
  }
  // z_acc
  output->z_acc = input->z_acc;
  // y_acc
  output->y_acc = input->y_acc;
  // x_acc
  output->x_acc = input->x_acc;
  // z_gyro
  output->z_gyro = input->z_gyro;
  // y_gyro
  output->y_gyro = input->y_gyro;
  // x_gyro
  output->x_gyro = input->x_gyro;
  return true;
}

novatel_oem7_msgs__msg__RAWIMUSX *
novatel_oem7_msgs__msg__RAWIMUSX__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  novatel_oem7_msgs__msg__RAWIMUSX * msg = (novatel_oem7_msgs__msg__RAWIMUSX *)allocator.allocate(sizeof(novatel_oem7_msgs__msg__RAWIMUSX), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(novatel_oem7_msgs__msg__RAWIMUSX));
  bool success = novatel_oem7_msgs__msg__RAWIMUSX__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
novatel_oem7_msgs__msg__RAWIMUSX__destroy(novatel_oem7_msgs__msg__RAWIMUSX * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    novatel_oem7_msgs__msg__RAWIMUSX__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
novatel_oem7_msgs__msg__RAWIMUSX__Sequence__init(novatel_oem7_msgs__msg__RAWIMUSX__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  novatel_oem7_msgs__msg__RAWIMUSX * data = NULL;

  if (size) {
    data = (novatel_oem7_msgs__msg__RAWIMUSX *)allocator.zero_allocate(size, sizeof(novatel_oem7_msgs__msg__RAWIMUSX), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = novatel_oem7_msgs__msg__RAWIMUSX__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        novatel_oem7_msgs__msg__RAWIMUSX__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
novatel_oem7_msgs__msg__RAWIMUSX__Sequence__fini(novatel_oem7_msgs__msg__RAWIMUSX__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      novatel_oem7_msgs__msg__RAWIMUSX__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

novatel_oem7_msgs__msg__RAWIMUSX__Sequence *
novatel_oem7_msgs__msg__RAWIMUSX__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  novatel_oem7_msgs__msg__RAWIMUSX__Sequence * array = (novatel_oem7_msgs__msg__RAWIMUSX__Sequence *)allocator.allocate(sizeof(novatel_oem7_msgs__msg__RAWIMUSX__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = novatel_oem7_msgs__msg__RAWIMUSX__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
novatel_oem7_msgs__msg__RAWIMUSX__Sequence__destroy(novatel_oem7_msgs__msg__RAWIMUSX__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    novatel_oem7_msgs__msg__RAWIMUSX__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
novatel_oem7_msgs__msg__RAWIMUSX__Sequence__are_equal(const novatel_oem7_msgs__msg__RAWIMUSX__Sequence * lhs, const novatel_oem7_msgs__msg__RAWIMUSX__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!novatel_oem7_msgs__msg__RAWIMUSX__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
novatel_oem7_msgs__msg__RAWIMUSX__Sequence__copy(
  const novatel_oem7_msgs__msg__RAWIMUSX__Sequence * input,
  novatel_oem7_msgs__msg__RAWIMUSX__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(novatel_oem7_msgs__msg__RAWIMUSX);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    novatel_oem7_msgs__msg__RAWIMUSX * data =
      (novatel_oem7_msgs__msg__RAWIMUSX *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!novatel_oem7_msgs__msg__RAWIMUSX__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          novatel_oem7_msgs__msg__RAWIMUSX__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!novatel_oem7_msgs__msg__RAWIMUSX__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
