// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from novatel_oem7_msgs:msg/RAWIMUSX.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "novatel_oem7_msgs/msg/rawimusx.hpp"


#ifndef NOVATEL_OEM7_MSGS__MSG__DETAIL__RAWIMUSX__TRAITS_HPP_
#define NOVATEL_OEM7_MSGS__MSG__DETAIL__RAWIMUSX__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "novatel_oem7_msgs/msg/detail/rawimusx__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'nov_header'
#include "novatel_oem7_msgs/msg/detail/oem7_header__traits.hpp"

namespace novatel_oem7_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RAWIMUSX & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: nov_header
  {
    out << "nov_header: ";
    to_flow_style_yaml(msg.nov_header, out);
    out << ", ";
  }

  // member: imu_info
  {
    out << "imu_info: ";
    rosidl_generator_traits::value_to_yaml(msg.imu_info, out);
    out << ", ";
  }

  // member: imu_type
  {
    out << "imu_type: ";
    rosidl_generator_traits::value_to_yaml(msg.imu_type, out);
    out << ", ";
  }

  // member: gnss_week
  {
    out << "gnss_week: ";
    rosidl_generator_traits::value_to_yaml(msg.gnss_week, out);
    out << ", ";
  }

  // member: gnss_week_seconds
  {
    out << "gnss_week_seconds: ";
    rosidl_generator_traits::value_to_yaml(msg.gnss_week_seconds, out);
    out << ", ";
  }

  // member: imu_status
  {
    if (msg.imu_status.size() == 0) {
      out << "imu_status: []";
    } else {
      out << "imu_status: [";
      size_t pending_items = msg.imu_status.size();
      for (auto item : msg.imu_status) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: z_acc
  {
    out << "z_acc: ";
    rosidl_generator_traits::value_to_yaml(msg.z_acc, out);
    out << ", ";
  }

  // member: y_acc
  {
    out << "y_acc: ";
    rosidl_generator_traits::value_to_yaml(msg.y_acc, out);
    out << ", ";
  }

  // member: x_acc
  {
    out << "x_acc: ";
    rosidl_generator_traits::value_to_yaml(msg.x_acc, out);
    out << ", ";
  }

  // member: z_gyro
  {
    out << "z_gyro: ";
    rosidl_generator_traits::value_to_yaml(msg.z_gyro, out);
    out << ", ";
  }

  // member: y_gyro
  {
    out << "y_gyro: ";
    rosidl_generator_traits::value_to_yaml(msg.y_gyro, out);
    out << ", ";
  }

  // member: x_gyro
  {
    out << "x_gyro: ";
    rosidl_generator_traits::value_to_yaml(msg.x_gyro, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RAWIMUSX & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: nov_header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "nov_header:\n";
    to_block_style_yaml(msg.nov_header, out, indentation + 2);
  }

  // member: imu_info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "imu_info: ";
    rosidl_generator_traits::value_to_yaml(msg.imu_info, out);
    out << "\n";
  }

  // member: imu_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "imu_type: ";
    rosidl_generator_traits::value_to_yaml(msg.imu_type, out);
    out << "\n";
  }

  // member: gnss_week
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gnss_week: ";
    rosidl_generator_traits::value_to_yaml(msg.gnss_week, out);
    out << "\n";
  }

  // member: gnss_week_seconds
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gnss_week_seconds: ";
    rosidl_generator_traits::value_to_yaml(msg.gnss_week_seconds, out);
    out << "\n";
  }

  // member: imu_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.imu_status.size() == 0) {
      out << "imu_status: []\n";
    } else {
      out << "imu_status:\n";
      for (auto item : msg.imu_status) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: z_acc
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "z_acc: ";
    rosidl_generator_traits::value_to_yaml(msg.z_acc, out);
    out << "\n";
  }

  // member: y_acc
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "y_acc: ";
    rosidl_generator_traits::value_to_yaml(msg.y_acc, out);
    out << "\n";
  }

  // member: x_acc
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "x_acc: ";
    rosidl_generator_traits::value_to_yaml(msg.x_acc, out);
    out << "\n";
  }

  // member: z_gyro
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "z_gyro: ";
    rosidl_generator_traits::value_to_yaml(msg.z_gyro, out);
    out << "\n";
  }

  // member: y_gyro
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "y_gyro: ";
    rosidl_generator_traits::value_to_yaml(msg.y_gyro, out);
    out << "\n";
  }

  // member: x_gyro
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "x_gyro: ";
    rosidl_generator_traits::value_to_yaml(msg.x_gyro, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RAWIMUSX & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace novatel_oem7_msgs

namespace rosidl_generator_traits
{

[[deprecated("use novatel_oem7_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const novatel_oem7_msgs::msg::RAWIMUSX & msg,
  std::ostream & out, size_t indentation = 0)
{
  novatel_oem7_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use novatel_oem7_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const novatel_oem7_msgs::msg::RAWIMUSX & msg)
{
  return novatel_oem7_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<novatel_oem7_msgs::msg::RAWIMUSX>()
{
  return "novatel_oem7_msgs::msg::RAWIMUSX";
}

template<>
inline const char * name<novatel_oem7_msgs::msg::RAWIMUSX>()
{
  return "novatel_oem7_msgs/msg/RAWIMUSX";
}

template<>
struct has_fixed_size<novatel_oem7_msgs::msg::RAWIMUSX>
  : std::integral_constant<bool, has_fixed_size<novatel_oem7_msgs::msg::Oem7Header>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<novatel_oem7_msgs::msg::RAWIMUSX>
  : std::integral_constant<bool, has_bounded_size<novatel_oem7_msgs::msg::Oem7Header>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<novatel_oem7_msgs::msg::RAWIMUSX>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // NOVATEL_OEM7_MSGS__MSG__DETAIL__RAWIMUSX__TRAITS_HPP_
